diff --git a/src/backend/access/spgist/spginsert.c b/src/backend/access/spgist/spginsert.c
new file mode 100644
index bceee8d..c95ae3d
*** a/src/backend/access/spgist/spginsert.c
--- b/src/backend/access/spgist/spginsert.c
*************** spgistBuildCallback(Relation index, Heap
*** 65,76 ****
  /*
   * Build an SP-GiST index.
   */
! Datum
! spgbuild(PG_FUNCTION_ARGS)
  {
- 	Relation	heap = (Relation) PG_GETARG_POINTER(0);
- 	Relation	index = (Relation) PG_GETARG_POINTER(1);
- 	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
  	IndexBuildResult *result;
  	double		reltuples;
  	SpGistBuildState buildstate;
--- 65,73 ----
  /*
   * Build an SP-GiST index.
   */
! IndexBuildResult *
! spgbuild(Relation heap, Relation index, IndexInfo *indexInfo)
  {
  	IndexBuildResult *result;
  	double		reltuples;
  	SpGistBuildState buildstate;
*************** spgbuild(PG_FUNCTION_ARGS)
*** 151,166 ****
  	result = (IndexBuildResult *) palloc0(sizeof(IndexBuildResult));
  	result->heap_tuples = result->index_tuples = reltuples;
  
! 	PG_RETURN_POINTER(result);
  }
  
  /*
   * Build an empty SPGiST index in the initialization fork
   */
! Datum
! spgbuildempty(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
  	Page		page;
  
  	/* Construct metapage. */
--- 148,162 ----
  	result = (IndexBuildResult *) palloc0(sizeof(IndexBuildResult));
  	result->heap_tuples = result->index_tuples = reltuples;
  
! 	return result;
  }
  
  /*
   * Build an empty SPGiST index in the initialization fork
   */
! void
! spgbuildempty(Relation index)
  {
  	Page		page;
  
  	/* Construct metapage. */
*************** spgbuildempty(PG_FUNCTION_ARGS)
*** 201,225 ****
  	 * checkpoint may have moved the redo pointer past our xlog record.
  	 */
  	smgrimmedsync(index->rd_smgr, INIT_FORKNUM);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   * Insert one new tuple into an SPGiST index.
   */
! Datum
! spginsert(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
- 	Datum	   *values = (Datum *) PG_GETARG_POINTER(1);
- 	bool	   *isnull = (bool *) PG_GETARG_POINTER(2);
- 	ItemPointer ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
- 
- #ifdef NOT_USED
- 	Relation	heapRel = (Relation) PG_GETARG_POINTER(4);
- 	IndexUniqueCheck checkUnique = (IndexUniqueCheck) PG_GETARG_INT32(5);
- #endif
  	SpGistState spgstate;
  	MemoryContext oldCtx;
  	MemoryContext insertCtx;
--- 197,212 ----
  	 * checkpoint may have moved the redo pointer past our xlog record.
  	 */
  	smgrimmedsync(index->rd_smgr, INIT_FORKNUM);
  }
  
  /*
   * Insert one new tuple into an SPGiST index.
   */
! bool
! spginsert(Relation index, Datum *values, bool *isnull,
! 		  ItemPointer ht_ctid, Relation heapRel,
! 		  IndexUniqueCheck checkUnique)
  {
  	SpGistState spgstate;
  	MemoryContext oldCtx;
  	MemoryContext insertCtx;
*************** spginsert(PG_FUNCTION_ARGS)
*** 251,255 ****
  	MemoryContextDelete(insertCtx);
  
  	/* return false since we've not done any unique check */
! 	PG_RETURN_BOOL(false);
  }
--- 238,242 ----
  	MemoryContextDelete(insertCtx);
  
  	/* return false since we've not done any unique check */
! 	return false;
  }
diff --git a/src/backend/access/spgist/spgscan.c b/src/backend/access/spgist/spgscan.c
new file mode 100644
index 8a0d909..1e73690
*** a/src/backend/access/spgist/spgscan.c
--- b/src/backend/access/spgist/spgscan.c
*************** spgPrepareScanKeys(IndexScanDesc scan)
*** 173,185 ****
  	}
  }
  
! Datum
! spgbeginscan(PG_FUNCTION_ARGS)
  {
- 	Relation	rel = (Relation) PG_GETARG_POINTER(0);
- 	int			keysz = PG_GETARG_INT32(1);
- 
- 	/* ScanKey			scankey = (ScanKey) PG_GETARG_POINTER(2); */
  	IndexScanDesc scan;
  	SpGistScanOpaque so;
  
--- 173,181 ----
  	}
  }
  
! IndexScanDesc
! spgbeginscan(Relation rel, int keysz, int orderbysz)
  {
  	IndexScanDesc scan;
  	SpGistScanOpaque so;
  
*************** spgbeginscan(PG_FUNCTION_ARGS)
*** 202,216 ****
  
  	scan->opaque = so;
  
! 	PG_RETURN_POINTER(scan);
  }
  
! Datum
! spgrescan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
- 	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(1);
  
  	/* copy scankeys into local storage */
  	if (scankey && scan->numberOfKeys > 0)
--- 198,212 ----
  
  	scan->opaque = so;
  
! 	return scan;
  }
  
! 
! void
! spgrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 		  ScanKey orderbys, int norderbys)
  {
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	/* copy scankeys into local storage */
  	if (scankey && scan->numberOfKeys > 0)
*************** spgrescan(PG_FUNCTION_ARGS)
*** 224,256 ****
  
  	/* set up starting stack entries */
  	resetSpGistScanOpaque(so);
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! spgendscan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	MemoryContextDelete(so->tempCxt);
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! spgmarkpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "SPGiST does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
! Datum
! spgrestrpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "SPGiST does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
  /*
--- 220,245 ----
  
  	/* set up starting stack entries */
  	resetSpGistScanOpaque(so);
  }
  
! void
! spgendscan(IndexScanDesc scan)
  {
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	MemoryContextDelete(so->tempCxt);
  }
  
! void
! spgmarkpos(IndexScanDesc scan)
  {
  	elog(ERROR, "SPGiST does not support mark/restore");
  }
  
! void
! spgrestrpos(IndexScanDesc scan)
  {
  	elog(ERROR, "SPGiST does not support mark/restore");
  }
  
  /*
*************** storeBitmap(SpGistScanOpaque so, ItemPoi
*** 571,581 ****
  	so->ntids++;
  }
  
! Datum
! spggetbitmap(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	TIDBitmap  *tbm = (TIDBitmap *) PG_GETARG_POINTER(1);
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	/* Copy want_itup to *so so we don't need to pass it around separately */
--- 560,568 ----
  	so->ntids++;
  }
  
! int64
! spggetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
  {
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	/* Copy want_itup to *so so we don't need to pass it around separately */
*************** spggetbitmap(PG_FUNCTION_ARGS)
*** 586,592 ****
  
  	spgWalk(scan->indexRelation, so, true, storeBitmap);
  
! 	PG_RETURN_INT64(so->ntids);
  }
  
  /* storeRes subroutine for gettuple case */
--- 573,579 ----
  
  	spgWalk(scan->indexRelation, so, true, storeBitmap);
  
! 	return so->ntids;
  }
  
  /* storeRes subroutine for gettuple case */
*************** storeGettuple(SpGistScanOpaque so, ItemP
*** 610,620 ****
  	so->nPtrs++;
  }
  
! Datum
! spggettuple(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanDirection dir = (ScanDirection) PG_GETARG_INT32(1);
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	if (dir != ForwardScanDirection)
--- 597,605 ----
  	so->nPtrs++;
  }
  
! bool
! spggettuple(IndexScanDesc scan, ScanDirection dir)
  {
  	SpGistScanOpaque so = (SpGistScanOpaque) scan->opaque;
  
  	if (dir != ForwardScanDirection)
*************** spggettuple(PG_FUNCTION_ARGS)
*** 632,638 ****
  			scan->xs_recheck = so->recheck[so->iPtr];
  			scan->xs_itup = so->indexTups[so->iPtr];
  			so->iPtr++;
! 			PG_RETURN_BOOL(true);
  		}
  
  		if (so->want_itup)
--- 617,623 ----
  			scan->xs_recheck = so->recheck[so->iPtr];
  			scan->xs_itup = so->indexTups[so->iPtr];
  			so->iPtr++;
! 			return true;
  		}
  
  		if (so->want_itup)
*************** spggettuple(PG_FUNCTION_ARGS)
*** 651,669 ****
  			break;				/* must have completed scan */
  	}
  
! 	PG_RETURN_BOOL(false);
  }
  
! Datum
! spgcanreturn(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
- 
- 	/* int			i = PG_GETARG_INT32(1); */
  	SpGistCache *cache;
  
  	/* We can do it if the opclass config function says so */
  	cache = spgGetCache(index);
  
! 	PG_RETURN_BOOL(cache->config.canReturnData);
  }
--- 636,651 ----
  			break;				/* must have completed scan */
  	}
  
! 	return false;
  }
  
! bool
! spgcanreturn(Relation index, int attno)
  {
  	SpGistCache *cache;
  
  	/* We can do it if the opclass config function says so */
  	cache = spgGetCache(index);
  
! 	return cache->config.canReturnData;
  }
diff --git a/src/backend/access/spgist/spgutils.c b/src/backend/access/spgist/spgutils.c
new file mode 100644
index f38287c..09c679b
*** a/src/backend/access/spgist/spgutils.c
--- b/src/backend/access/spgist/spgutils.c
***************
*** 24,30 ****
--- 24,126 ----
  #include "storage/indexfsm.h"
  #include "storage/lmgr.h"
  #include "utils/lsyscache.h"
+ #include "utils/selfuncs.h"
+ 
+ 
+ /*
+  * SP-GiST handler function: return IndexAmRoutine with access method parameters
+  * and callbacks.
+  */
+ Datum
+ spghandler(PG_FUNCTION_ARGS)
+ {
+ 	IndexAmRoutine *amroutine = makeNode(IndexAmRoutine);
+ 
+ 	amroutine->amstrategies = 0;
+ 	amroutine->amsupport = 5;
+ 	amroutine->amcanorder = false;
+ 	amroutine->amcanorderbyop = false;
+ 	amroutine->amcanbackward = false;
+ 	amroutine->amcanunique = false;
+ 	amroutine->amcanmulticol = false;
+ 	amroutine->amoptionalkey = true;
+ 	amroutine->amsearcharray = false;
+ 	amroutine->amsearchnulls = true;
+ 	amroutine->amstorage = false;
+ 	amroutine->amclusterable = false;
+ 	amroutine->ampredlocks = false;
+ 	amroutine->amkeytype = 0;
+ 
+ 	amroutine->aminsert = spginsert;
+ 	amroutine->ambeginscan = spgbeginscan;
+ 	amroutine->amgettuple = spggettuple;
+ 	amroutine->amgetbitmap = spggetbitmap;
+ 	amroutine->amrescan = spgrescan;
+ 	amroutine->amendscan = spgendscan;
+ 	amroutine->ammarkpos = spgmarkpos;
+ 	amroutine->amrestrpos = spgrestrpos;
+ 	amroutine->ambuild = spgbuild;
+ 	amroutine->ambuildempty = spgbuildempty;
+ 	amroutine->ambulkdelete = spgbulkdelete;
+ 	amroutine->amvacuumcleanup = spgvacuumcleanup;
+ 	amroutine->amcanreturn = spgcanreturn;
+ 	amroutine->amcostestimate = spgcostestimate;
+ 	amroutine->amoptions = spgoptions;
+ 	amroutine->amvalidate = spgvalidate;
+ 
+ 	PG_RETURN_POINTER(amroutine);
+ }
+ 
+ void
+ spgvalidate(OpClassInfo *opclass)
+ {
+ 	ListCell   *l;
+ 	bool		procsPresent[SPGISTNProc];
+ 	int			i;
  
+ 	memset(procsPresent, 0, sizeof(procsPresent));
+ 
+ 	foreach(l, opclass->procedures)
+ 	{
+ 		OpFamilyMember *proc = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (proc->lefttype != opclass->intype ||
+ 			proc->righttype != opclass->intype)
+ 			continue;
+ 
+ 		if (proc->number < 1 || proc->number > SPGISTNProc)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("invalid support number for SP-GiST: %u",
+ 							proc->number)));
+ 
+ 		if (procsPresent[proc->number - 1])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("SP-GiST support number %u was defined more than once",
+ 							proc->number)));
+ 
+ 		procsPresent[proc->number - 1] = true;
+ 	}
+ 
+ 	for (i = 0; i < SPGISTNProc; i++)
+ 	{
+ 		if (!procsPresent[i])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("SP-GiST support number %u is required", i + 1)));
+ 	}
+ 
+ 	foreach(l, opclass->operators)
+ 	{
+ 		OpFamilyMember *opr = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (OidIsValid(opr->sortfamily))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("SP-GiST doesn't support ORDER BY operators")));
+ 	}
+ }
  
  /* Fill in a SpGistTypeDesc struct with info about the specified data type */
  static void
*************** SpGistInitMetapage(Page page)
*** 489,506 ****
  /*
   * reloptions processing for SPGiST
   */
! Datum
! spgoptions(PG_FUNCTION_ARGS)
  {
- 	Datum		reloptions = PG_GETARG_DATUM(0);
- 	bool		validate = PG_GETARG_BOOL(1);
  	bytea	   *result;
  
  	result = default_reloptions(reloptions, validate, RELOPT_KIND_SPGIST);
  
  	if (result)
! 		PG_RETURN_BYTEA_P(result);
! 	PG_RETURN_NULL();
  }
  
  /*
--- 585,600 ----
  /*
   * reloptions processing for SPGiST
   */
! bytea *
! spgoptions(Datum reloptions, bool validate)
  {
  	bytea	   *result;
  
  	result = default_reloptions(reloptions, validate, RELOPT_KIND_SPGIST);
  
  	if (result)
! 		return (bytea *)result;
! 	return NULL;
  }
  
  /*
diff --git a/src/backend/access/spgist/spgvacuum.c b/src/backend/access/spgist/spgvacuum.c
new file mode 100644
index 06c0b0a..c3856a1
*** a/src/backend/access/spgist/spgvacuum.c
--- b/src/backend/access/spgist/spgvacuum.c
*************** spgvacuumscan(spgBulkDeleteState *bds)
*** 881,893 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! spgbulkdelete(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 	IndexBulkDeleteCallback callback = (IndexBulkDeleteCallback) PG_GETARG_POINTER(2);
- 	void	   *callback_state = (void *) PG_GETARG_POINTER(3);
  	spgBulkDeleteState bds;
  
  	/* allocate stats if first time through, else re-use existing struct */
--- 881,890 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! spgbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
! 			  IndexBulkDeleteCallback callback, void *callback_state)
  {
  	spgBulkDeleteState bds;
  
  	/* allocate stats if first time through, else re-use existing struct */
*************** spgbulkdelete(PG_FUNCTION_ARGS)
*** 900,906 ****
  
  	spgvacuumscan(&bds);
  
! 	PG_RETURN_POINTER(stats);
  }
  
  /* Dummy callback to delete no tuples during spgvacuumcleanup */
--- 897,903 ----
  
  	spgvacuumscan(&bds);
  
! 	return stats;
  }
  
  /* Dummy callback to delete no tuples during spgvacuumcleanup */
*************** dummy_callback(ItemPointer itemptr, void
*** 915,931 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! spgvacuumcleanup(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
  	Relation	index = info->index;
  	spgBulkDeleteState bds;
  
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		PG_RETURN_POINTER(stats);
  
  	/*
  	 * We don't need to scan the index if there was a preceding bulkdelete
--- 912,926 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! spgvacuumcleanup(IndexVacuumInfo *info, IndexBulkDeleteResult *stats)
  {
  	Relation	index = info->index;
  	spgBulkDeleteState bds;
  
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		return stats;
  
  	/*
  	 * We don't need to scan the index if there was a preceding bulkdelete
*************** spgvacuumcleanup(PG_FUNCTION_ARGS)
*** 959,963 ****
  			stats->num_index_tuples = info->num_heap_tuples;
  	}
  
! 	PG_RETURN_POINTER(stats);
  }
--- 954,958 ----
  			stats->num_index_tuples = info->num_heap_tuples;
  	}
  
! 	return stats;
  }
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
new file mode 100644
index e59b163..4e21304
*** a/src/backend/catalog/index.c
--- b/src/backend/catalog/index.c
***************
*** 23,28 ****
--- 23,29 ----
  
  #include <unistd.h>
  
+ #include "access/amapi.h"
  #include "access/multixact.h"
  #include "access/relscan.h"
  #include "access/sysattr.h"
*************** ConstructTupleDescriptor(Relation heapRe
*** 277,296 ****
  	int			numatts = indexInfo->ii_NumIndexAttrs;
  	ListCell   *colnames_item = list_head(indexColNames);
  	ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
! 	HeapTuple	amtuple;
! 	Form_pg_am	amform;
  	TupleDesc	heapTupDesc;
  	TupleDesc	indexTupDesc;
  	int			natts;			/* #atts in heap rel --- for error checks */
  	int			i;
  
  	/* We need access to the index AM's pg_am tuple */
! 	amtuple = SearchSysCache1(AMOID,
! 							  ObjectIdGetDatum(accessMethodObjectId));
! 	if (!HeapTupleIsValid(amtuple))
! 		elog(ERROR, "cache lookup failed for access method %u",
! 			 accessMethodObjectId);
! 	amform = (Form_pg_am) GETSTRUCT(amtuple);
  
  	/* ... and to the table's tuple descriptor */
  	heapTupDesc = RelationGetDescr(heapRelation);
--- 278,291 ----
  	int			numatts = indexInfo->ii_NumIndexAttrs;
  	ListCell   *colnames_item = list_head(indexColNames);
  	ListCell   *indexpr_item = list_head(indexInfo->ii_Expressions);
! 	IndexAmRoutine  *amroutine;
  	TupleDesc	heapTupDesc;
  	TupleDesc	indexTupDesc;
  	int			natts;			/* #atts in heap rel --- for error checks */
  	int			i;
  
  	/* We need access to the index AM's pg_am tuple */
! 	amroutine = GetIndexAmRoutineByAmId(accessMethodObjectId);
  
  	/* ... and to the table's tuple descriptor */
  	heapTupDesc = RelationGetDescr(heapRelation);
*************** ConstructTupleDescriptor(Relation heapRe
*** 437,443 ****
  		if (OidIsValid(opclassTup->opckeytype))
  			keyType = opclassTup->opckeytype;
  		else
! 			keyType = amform->amkeytype;
  		ReleaseSysCache(tuple);
  
  		if (OidIsValid(keyType) && keyType != to->atttypid)
--- 432,438 ----
  		if (OidIsValid(opclassTup->opckeytype))
  			keyType = opclassTup->opckeytype;
  		else
! 			keyType = amroutine->amkeytype;
  		ReleaseSysCache(tuple);
  
  		if (OidIsValid(keyType) && keyType != to->atttypid)
*************** ConstructTupleDescriptor(Relation heapRe
*** 459,466 ****
  		}
  	}
  
- 	ReleaseSysCache(amtuple);
- 
  	return indexTupDesc;
  }
  
--- 454,459 ----
*************** index_build(Relation heapRelation,
*** 1988,1994 ****
  			bool isprimary,
  			bool isreindex)
  {
- 	RegProcedure procedure;
  	IndexBuildResult *stats;
  	Oid			save_userid;
  	int			save_sec_context;
--- 1981,1986 ----
*************** index_build(Relation heapRelation,
*** 1998,2007 ****
  	 * sanity checks
  	 */
  	Assert(RelationIsValid(indexRelation));
! 	Assert(PointerIsValid(indexRelation->rd_am));
! 
! 	procedure = indexRelation->rd_am->ambuild;
! 	Assert(RegProcedureIsValid(procedure));
  
  	ereport(DEBUG1,
  			(errmsg("building index \"%s\" on table \"%s\"",
--- 1990,1997 ----
  	 * sanity checks
  	 */
  	Assert(RelationIsValid(indexRelation));
! 	Assert(PointerIsValid(indexRelation->amroutine));
! 	Assert(PointerIsValid(indexRelation->amroutine->ambuild));
  
  	ereport(DEBUG1,
  			(errmsg("building index \"%s\" on table \"%s\"",
*************** index_build(Relation heapRelation,
*** 2021,2031 ****
  	/*
  	 * Call the access method's build procedure
  	 */
! 	stats = (IndexBuildResult *)
! 		DatumGetPointer(OidFunctionCall3(procedure,
! 										 PointerGetDatum(heapRelation),
! 										 PointerGetDatum(indexRelation),
! 										 PointerGetDatum(indexInfo)));
  	Assert(PointerIsValid(stats));
  
  	/*
--- 2011,2018 ----
  	/*
  	 * Call the access method's build procedure
  	 */
! 	stats = indexRelation->amroutine->ambuild(heapRelation, indexRelation,
! 											  indexInfo);
  	Assert(PointerIsValid(stats));
  
  	/*
*************** index_build(Relation heapRelation,
*** 2038,2048 ****
  	if (indexRelation->rd_rel->relpersistence == RELPERSISTENCE_UNLOGGED &&
  		!smgrexists(indexRelation->rd_smgr, INIT_FORKNUM))
  	{
- 		RegProcedure ambuildempty = indexRelation->rd_am->ambuildempty;
- 
  		RelationOpenSmgr(indexRelation);
  		smgrcreate(indexRelation->rd_smgr, INIT_FORKNUM, false);
! 		OidFunctionCall1(ambuildempty, PointerGetDatum(indexRelation));
  	}
  
  	/*
--- 2025,2033 ----
  	if (indexRelation->rd_rel->relpersistence == RELPERSISTENCE_UNLOGGED &&
  		!smgrexists(indexRelation->rd_smgr, INIT_FORKNUM))
  	{
  		RelationOpenSmgr(indexRelation);
  		smgrcreate(indexRelation->rd_smgr, INIT_FORKNUM, false);
! 		indexRelation->amroutine->ambuildempty(indexRelation);
  	}
  
  	/*
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
new file mode 100644
index 7ab4874..7a7fd95
*** a/src/backend/commands/cluster.c
--- b/src/backend/commands/cluster.c
***************
*** 17,22 ****
--- 17,23 ----
   */
  #include "postgres.h"
  
+ #include "access/amapi.h"
  #include "access/multixact.h"
  #include "access/relscan.h"
  #include "access/rewriteheap.h"
*************** check_index_is_clusterable(Relation OldH
*** 433,439 ****
  						RelationGetRelationName(OldHeap))));
  
  	/* Index AM must allow clustering */
! 	if (!OldIndex->rd_am->amclusterable)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("cannot cluster on index \"%s\" because access method does not support clustering",
--- 434,440 ----
  						RelationGetRelationName(OldHeap))));
  
  	/* Index AM must allow clustering */
! 	if (!OldIndex->amroutine->amclusterable)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  				 errmsg("cannot cluster on index \"%s\" because access method does not support clustering",
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
new file mode 100644
index b450bcf..b794d59
*** a/src/backend/commands/indexcmds.c
--- b/src/backend/commands/indexcmds.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "postgres.h"
  
+ #include "access/amapi.h"
  #include "access/htup_details.h"
  #include "access/reloptions.h"
  #include "access/xact.h"
*************** CheckIndexCompatible(Oid oldId,
*** 125,130 ****
--- 126,132 ----
  	HeapTuple	tuple;
  	Form_pg_index indexForm;
  	Form_pg_am	accessMethodForm;
+ 	IndexAmRoutine *amRoutine;
  	bool		amcanorder;
  	int16	   *coloptions;
  	IndexInfo  *indexInfo;
*************** CheckIndexCompatible(Oid oldId,
*** 160,166 ****
  						accessMethodName)));
  	accessMethodId = HeapTupleGetOid(tuple);
  	accessMethodForm = (Form_pg_am) GETSTRUCT(tuple);
! 	amcanorder = accessMethodForm->amcanorder;
  	ReleaseSysCache(tuple);
  
  	/*
--- 162,169 ----
  						accessMethodName)));
  	accessMethodId = HeapTupleGetOid(tuple);
  	accessMethodForm = (Form_pg_am) GETSTRUCT(tuple);
! 	amRoutine = GetIndexAmRoutine(accessMethodForm->amhandler);
! 	amcanorder = amRoutine->amcanorder;
  	ReleaseSysCache(tuple);
  
  	/*
*************** DefineIndex(Oid relationId,
*** 315,322 ****
  	Relation	indexRelation;
  	HeapTuple	tuple;
  	Form_pg_am	accessMethodForm;
  	bool		amcanorder;
! 	RegProcedure amoptions;
  	Datum		reloptions;
  	int16	   *coloptions;
  	IndexInfo  *indexInfo;
--- 318,326 ----
  	Relation	indexRelation;
  	HeapTuple	tuple;
  	Form_pg_am	accessMethodForm;
+ 	IndexAmRoutine *amRoutine;
  	bool		amcanorder;
! 	amoptions_function amoptions;
  	Datum		reloptions;
  	int16	   *coloptions;
  	IndexInfo  *indexInfo;
*************** DefineIndex(Oid relationId,
*** 489,518 ****
  	}
  	accessMethodId = HeapTupleGetOid(tuple);
  	accessMethodForm = (Form_pg_am) GETSTRUCT(tuple);
  
  	if (strcmp(accessMethodName, "hash") == 0 &&
  		RelationNeedsWAL(rel))
  		ereport(WARNING,
  				(errmsg("hash indexes are not WAL-logged and their use is discouraged")));
  
! 	if (stmt->unique && !accessMethodForm->amcanunique)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  			   errmsg("access method \"%s\" does not support unique indexes",
  					  accessMethodName)));
! 	if (numberOfAttributes > 1 && !accessMethodForm->amcanmulticol)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  		  errmsg("access method \"%s\" does not support multicolumn indexes",
  				 accessMethodName)));
! 	if (stmt->excludeOpNames && !OidIsValid(accessMethodForm->amgettuple))
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  		errmsg("access method \"%s\" does not support exclusion constraints",
  			   accessMethodName)));
  
! 	amcanorder = accessMethodForm->amcanorder;
! 	amoptions = accessMethodForm->amoptions;
  
  	ReleaseSysCache(tuple);
  
--- 493,523 ----
  	}
  	accessMethodId = HeapTupleGetOid(tuple);
  	accessMethodForm = (Form_pg_am) GETSTRUCT(tuple);
+ 	amRoutine = GetIndexAmRoutine(accessMethodForm->amhandler);
  
  	if (strcmp(accessMethodName, "hash") == 0 &&
  		RelationNeedsWAL(rel))
  		ereport(WARNING,
  				(errmsg("hash indexes are not WAL-logged and their use is discouraged")));
  
! 	if (stmt->unique && !amRoutine->amcanunique)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  			   errmsg("access method \"%s\" does not support unique indexes",
  					  accessMethodName)));
! 	if (numberOfAttributes > 1 && !amRoutine->amcanmulticol)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  		  errmsg("access method \"%s\" does not support multicolumn indexes",
  				 accessMethodName)));
! 	if (stmt->excludeOpNames && !OidIsValid(amRoutine->amgettuple))
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
  		errmsg("access method \"%s\" does not support exclusion constraints",
  			   accessMethodName)));
  
! 	amcanorder = amRoutine->amcanorder;
! 	amoptions = amRoutine->amoptions;
  
  	ReleaseSysCache(tuple);
  
